/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.uluru.platform.jbpm.process;

import com.uluru.common.api.BeanLocator;
import com.uluru.common.api.Constants;
import com.uluru.platform.process.AbstractBaseProcess;
import com.uluru.platform.process.ProcessItem;
import java.util.HashMap;
import java.util.Map;
import org.apache.commons.pool.impl.GenericKeyedObjectPool;
import org.apache.log4j.Logger;
import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;

/**
 *
 * @author donaldwalters
 */
public class ProcessExecutionHandler implements WorkItemHandler {

    private static final GenericKeyedObjectPool pool = new GenericKeyedObjectPool(new ProcessObjectPoolFactory(), GenericKeyedObjectPool.DEFAULT_MAX_ACTIVE, 
            GenericKeyedObjectPool.WHEN_EXHAUSTED_GROW, GenericKeyedObjectPool.DEFAULT_MAX_WAIT, GenericKeyedObjectPool.DEFAULT_MAX_IDLE);
    
    private Logger log = Logger.getLogger(ProcessExecutionHandler.class);
    private static Object helper;

    public ProcessExecutionHandler(Object h) {
        helper = h;
    }

    public static Object getHelper() {
        return helper;
    }

    @Override
    public void executeWorkItem(WorkItem workItem, WorkItemManager manager) {
        log.debug(workItem);

        ProcessItem processItem = (ProcessItem) workItem.getParameter(Constants.PROCESS_ITEM);
        Map<String, Object> params = workItem.getParameters();
        params.remove("Interface");
        params.remove("Operation");
        params.remove("ParameterType");
        params.remove(Constants.PROCESS_ITEM);

        try {
            String type = (String) workItem.getParameter(AbstractBaseProcess.PROCESS_TYPE);

            if (log.isTraceEnabled()) {
                log.trace("looking up activity key=" + type + " params " + params);
                log.trace("PROCESS ITEM ====== " + processItem);
            }

            AbstractBaseProcess process = (AbstractBaseProcess) pool.borrowObject(type);
            process.setProperties(params);
//                process = ProcessFactory.getFactory().getProcess(type, params);

            process.setServiceContext(processItem.getVariable(Constants.SERVICE_CONTEXT));
            process.setBeanLocator((BeanLocator) helper);

            log.debug("found activity key=" + type + " activity=" + process);

            processItem.addVariable(Constants.PROCESS_INSTANCE_ID, workItem.getProcessInstanceId());
            processItem.addVariable(Constants.EVENT_SIGNAL_REF, workItem.getParameter(Constants.EVENT_SIGNAL_REF));

            ProcessItem result = process.execute(processItem);

            pool.returnObject(type, process);

            Map<String, Object> results = new HashMap<String, Object>();
            results.put(Constants.PROCESS_ITEM, result);

            manager.completeWorkItem(workItem.getId(), results);
        } catch (Exception e) {
            log.error("error occur in process handler - couldn't complete process", e);
        }
    }

    @Override
    public void abortWorkItem(WorkItem wi, WorkItemManager wim) {
    }
}
